package com.gree.mall.miniapp.controller.coupon;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gree.mall.miniapp.bean.coupon.*;
import com.gree.mall.miniapp.constant.Constant;
import com.gree.mall.miniapp.exception.RemoteServiceException;
import com.gree.mall.miniapp.helper.ResponseHelper;
import com.gree.mall.miniapp.logic.coupon.CouponLogic;
import com.gree.mall.miniapp.plus.entity.Coupon;
import com.gree.mall.miniapp.plus.entity.UserCoupon;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.integration.redis.util.RedisLockRegistry;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Lock;

@Slf4j
@RestController
@Api(value = "新优惠券", tags = {"新优惠券"})
@RequestMapping(value = "/couponNew", produces = "application/json; charset=utf-8")
public class CouponNewController {

    @Autowired
    CouponLogic couponLogic;
    @Autowired
    RedisLockRegistry redisLockRegistry;


    @GetMapping("/list/all")
    @ApiOperation(value = "待领优惠券列表")
    public ResponseHelper<List<Coupon>> listAll(
            HttpServletRequest request
    ) throws RemoteServiceException {
        List<Coupon> coupons = couponLogic.listAll(request);
        return ResponseHelper.success(coupons);
    }

    @GetMapping("/obtain")
    @ApiOperation(value = "领券")
    public ResponseHelper obtain(HttpServletRequest request,
                                 @ApiParam(value = "用户id") @RequestParam(required = false) String userId,
                                 @ApiParam(value = "优惠券id") @RequestParam(required = false) List<String> couponIds
    ) throws RemoteServiceException, InterruptedException {

        couponLogic.getCoupon(request, userId, couponIds);

        return ResponseHelper.success();
    }

}


